{
  description = "A very basic python flake";

  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs?ref=nixos-unstable";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = nixpkgs.legacyPackages.${system};
        shell = "zsh";
      in {
        devShell = pkgs.mkShell {
          buildInputs = with pkgs; [
            python3
            pyright
            black
          ];
          shellHook = ''
            source .env.sh
            exec ${shell}
          '';
        };
      });
}
